<script lang="ts">
  import { ManagedPromise } from '@typhonjs-fvtt/runtime/util/async'
  import { getContext } from 'svelte'
  import { BaseCharacter } from '../../module/model/character.js'

  export var localize: (key: string) => string = () => ''
  export var character: BaseCharacter

  const options = {
    comfort: '0',
    weather: 0,
    restInterrupted: false,
    keptWatch: false,
    badEncampment: false,
    vitalityMod: 0,
    astralEnergyMod: 0,
  }

  $: restingParameters = character.determineResting({
    ...options,
    comfort: Number.parseInt(options.comfort),
  })

  const managedPromise = getContext<ManagedPromise>('#managedPromise')
  managedPromise
    .get()
    .then((result) => result === true && character.rest(restingParameters))

  function formatRoll(options) {
    const bonus =
      options.modifier >= 0 ? `+${options.modifier}` : options.modifier

    if (!options.roll) {
      return bonus
    }

    return options.modifier !== 0 ? `1d6 ${bonus}` : '1d6'
  }
</script>

<div style="font-size: large">
  <div class="resting-property">
    {localize('comfort')}
    <select
      class="select"
      bind:value={options.comfort}
      data-testid="comfort-input"
    >
      {#each ['0', '1', '2'] as comfortOption}
        <option value={comfortOption}
          >{localize(`restingComfort${comfortOption}`)}</option
        >
      {/each}
    </select>
  </div>

  <div class="resting-property" data-testid="weather-mod">
    {localize('weather')}: {options.weather}
    <input
      type="range"
      min="-5"
      max="0"
      step="1.0"
      bind:value={options.weather}
      data-testid="weather-input"
    />
  </div>

  <div class="resting-property">
    <input
      type="checkbox"
      bind:checked={options.restInterrupted}
      data-testid="restInterrupted-checkbox"
    />
    {localize('restInterrupted')}
  </div>

  <div class="resting-property">
    <input
      type="checkbox"
      bind:checked={options.keptWatch}
      data-testid="keptWatch-checkbox"
    />
    {localize('keptWatch')}
  </div>

  <div class="resting-property">
    <input
      type="checkbox"
      bind:checked={options.badEncampment}
      data-testid="badEncampment-checkbox"
    />
    {localize('badEncampment')}
  </div>

  {#if restingParameters.vitality}
    <h2 data-testid="vitality-mod">
      {localize('vitalityMod')}: {formatRoll(restingParameters.vitality)}
    </h2>
    <input
      type="number"
      bind:value={options.vitalityMod}
      data-testid="vitalityMod-input"
    />
  {/if}

  {#if restingParameters.astralEnergy}
    <h2 data-testid="astralEnergy-mod">
      {localize('astralEnergyMod')}: {formatRoll(
        restingParameters.astralEnergy
      )}
    </h2>
    <input
      type="number"
      bind:value={options.astralEnergyMod}
      data-testid="astralEnergyMod-input"
    />
  {/if}
</div>

<style>
  .select {
    width: 100%;
  }

  .resting-property {
    margin-bottom: 6px;
  }
</style>
